PetDownloader = { }
local NUM_PET_ABILITIES = 6;

function PetDownloader_Download(msg)
   
   PetDownloader = {
      ["name"] = { },
      ["peticon"] = { },
      ["pettype"] = { },
      ["speciesid"] = { },
      ["creatureid"] = { },
      ["sourcetext"] = { },
      ["petdesc"] = { },
      ["wild"] = { },
      ["cooldown"] = { },
      ["level"] = { },
      ["petid"] = { },
      ["health"] = { },
      ["maxhealth"] = { },
      ["attack"] = { },
      ["speed"] = { },
      ["rarity"] = { },
      ["link"] = { },
      ["index"] = { },
      ["ability"] = { },
      ["petability"] = { { } },
      ["petabilityicon"] = { { } },
      ["petabilitytext"] = { { } },
      ["petabilityname"] = { { } },
      ["petabilityid"] = { { } },
      ["petabilityindex"] = { { } }
   }
   
   local p=C_PetJournal
   p.AddAllPetSourcesFilter(true)
   p.AddAllPetTypesFilter(true)
   p.ClearSearchFilter(true)
   local numPets, numOwned = p.GetNumPets(false);
   --print("Checking " .. numPets .. " pets.");
   for i=1,numPets do
      local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle = C_PetJournal.GetPetInfoByIndex(i);
      sourceText=string.gsub(sourceText,"Valley of Four Winds","Valley of the Four Winds")
      local health, maxHealth, attack, speed, rarity = p.GetPetStats(petID)
      local link = p.GetBattlePetLink(petID) or 0
      PetDownloader[i] = petID;
      
      if canBattle then 
         table.insert(PetDownloader.name, name);
         table.insert(PetDownloader.peticon, icon);
         table.insert(PetDownloader.pettype, petType);
         table.insert(PetDownloader.speciesid, speciesID);
         table.insert(PetDownloader.creatureid, creatureID);
         table.insert(PetDownloader.petdesc, description);
         table.insert(PetDownloader.sourcetext, sourceText);
         table.insert(PetDownloader.wild, isWildPet);
         table.insert(PetDownloader.level, level);
         table.insert(PetDownloader.petid, petID);
         table.insert(PetDownloader.health, health);
         table.insert(PetDownloader.maxhealth, maxhealth);
         table.insert(PetDownloader.attack, attack);
         table.insert(PetDownloader.speed, speed);
         table.insert(PetDownloader.rarity, rarity);
         table.insert(PetDownloader.link, link);
         table.insert(PetDownloader.index, i);
         local abilities, levels = C_PetJournal.GetPetAbilityList(speciesID);
         PetDownloader["petability"][i] = {}
         PetDownloader["petabilityname"][i] = {}
         PetDownloader["petabilityicon"][i] = {}
         PetDownloader["petabilitytext"][i] = {}
         PetDownloader["petabilityindex"][i] = {}
         PetDownloader[name] = i
         --if petID > 0 and not PetDownloader[petID] then PetDownloader[petID] = i end
         local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle = C_PetJournal.GetPetInfoByIndex(i);
         sourceText=string.gsub(sourceText,"Valley of Four Winds","Valley of the Four Winds")
         local health, maxHealth, attack, speed, rarity = p.GetPetStats(petID)
         local abilities, levels = C_PetJournal.GetPetAbilityList(speciesID);
         for j=1,# abilities do
            local abilid, abilname, abilicon, maxCooldown, unparsedDescription, numTurns, abiltype, noStrongWeakHints = C_PetBattles.GetAbilityInfoByID(abilities[j]);
            --PetDownloader["petabilityname"][abilid] = abilname
            PetDownloader["petabilityname"][i][j]= abilname
            PetDownloader["petabilityicon"][i][j]= abilicon
            PetDownloader["petabilityindex"][i][j]= abilid
            PetDownloader["petabilityid"][abilname] = abilid
            
            THIS_PET_BATTLE_ABILITY_INFO = {};
            function THIS_PET_BATTLE_ABILITY_INFO:GetAbilityID() return abilid end
            function THIS_PET_BATTLE_ABILITY_INFO:GetCooldown() return 0 end
            function THIS_PET_BATTLE_ABILITY_INFO:GetRemainingDuration() return 0 end
            function THIS_PET_BATTLE_ABILITY_INFO:IsInBattle() return false end
            function THIS_PET_BATTLE_ABILITY_INFO:GetHealth(target) return 100 end
            function THIS_PET_BATTLE_ABILITY_INFO:GetMaxHealth(target) return 100 end
            function THIS_PET_BATTLE_ABILITY_INFO:GetAttackStat(target) return 0 end
            function THIS_PET_BATTLE_ABILITY_INFO:GetSpeedStat(target) return 0 end
            function THIS_PET_BATTLE_ABILITY_INFO:GetState(stateID, target) return 0 end
            function THIS_PET_BATTLE_ABILITY_INFO:GetWeatherState(stateID) return 0 end
            function THIS_PET_BATTLE_ABILITY_INFO:GetPetOwner(target) return LE_BATTLE_PET_ALLY end
            function THIS_PET_BATTLE_ABILITY_INFO:HasAura(auraID, target) return false end
            function THIS_PET_BATTLE_ABILITY_INFO:GetPetType(target) if ( self:IsInBattle() ) then error("UI: Unimplemented Function"); else return abiltype end end
            local parsed = SharedPetAbilityTooltip_ParseText(THIS_PET_BATTLE_ABILITY_INFO, unparsedDescription)
            PetDownloader["petabilitytext"][i][j]= parsed
         end
      end
   end
end

SLASH_PETDOWNLOADER1 = "/petdl";
SlashCmdList["PETDOWNLOADER"] = PetDownloader_Download;
PetDownloader_Download()